# Contributing Guide

First off, thanks for taking time to contribute. We really appreciate every
contribution in form of reports, requests, discussions or every other bit, that
will help to grow the project.

Please read the below text carefully before contributing.

## General

Please try to open new issues, write commits or open pull-requests in a
[short and self-contained](http://www.sscce.org/) manner. For many situations,
we also provided template issues, which should be used to open a new one.

## :bug: Bug Reports

Reporting Bugs should follow some simple rules:

- **Check**, if you can find similar bugs
- **Describe** what is happening and what should happen
- **Explain** how to reproduce the problem
- **Add** more details and attachments
- **Follow up**, if somebody is having questions or needs more details

## :heart: Enhancements

Requesting a new feature or enhancement is also following some simple rules:

- **Check**, if the feature is already requested
- **Describe** what your feature will bring to the community
- **Explain** the criteria to fulfill the request
- **Add** more details like mock ups, attachments, lists, screenshots
- **Follow Up** in the discussion to the feature

## :pencil: Code Contribution

Contributing code should be as easy as possible. In general, we are following
the below process.

- **File an issue** for each code contribution (see above)
- **One Contribution** should solve one **issue**
- **Tested** code is **cool** code
- **Documented** code is **maintainable** code
- **Commit Messages** should be in
  [Conventional Commit Format](https://www.conventionalcommits.org/)
  (see .gitmessage)
- **Rebase** before opening the pull request/merge request

## :lock: Code Signing

It is common practice to sign your code, so it can be assured that the commit is
made by you. We are not enforcing this practice, but would be happy, if you
consider signing your commits properly.
